=== debian/changelog ===
libjpeg-turbo (1:2.0.6-4) unstable; urgency=medium

  [ Adrian Bunk ]
  * debian/patches:
    + Add 0001-cmake-MATCHES-uses-regex-not-globs.patch. Fix for cmake MATCHES
      to fix sparc64 FTBFS.

  [ Mike Gabriel ]
  * debian/patches:
    + Add 1002_jpeg-skip-scanlines-avoid-NULL+0-UBSan-error.patch.
      jpeg_skip_scanlines(): Avoid NULL + 0 UBSan error. (CVE-2021-0384).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 14 Mar 2021 15:45:05 +0100

libjpeg-turbo (1:2.0.6-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * debian/patches:
    + Add 0001-cmake-MATCHES-uses-regex-not-globs.patch. Fix for cmake MATCHES
      to fix sparc64 FTBFS

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 01 Mar 2021 10:29:14 +0100

libjpeg-turbo (1:2.0.6-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * debian/rules:
    + Fix test result comparison for several architectures with 2.0.6.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 23 Feb 2021 12:15:18 +0100

libjpeg-turbo (1:2.0.6-1) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * debian/extra/Makefile:
    + Do not pass user and group to install command.
  * debian/control:
    + Re-add Rules-Requires-Root: field. (Closes: #978998).

  [ Mike Gabriel ]
  * New upstream version 2.0.6
  * debian/patches:
    + Rebase 2001_dont-set-RPATH.patch.
    + Add Forwarded: field to 2001_dont-set-RPATH.patch's header. The patch is
      Debian-specific.
  * debian/upstream/signing-key.asc:
    + Add file (GnuPG key: 0x7EC2DBB6F4DBF434).
  * debian/watch:
    + Add pgpsigurlmangle option.
    + Switch to format version 4.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Make copyright attributions more precise, update for this upstream
      release.
  * debian/missing-sources:
    + Update jquery.js from 1.7.1 to 3.4.1 (same version as used in pre-built
      doxygen docs).
  * debian/source/lintian-overrides:
    + Silence lintian that rightfully complains about pre-built doxygen docs
      being shipped in the src:pkg. Amending this is on the todo list.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 15 Feb 2021 13:39:05 +0100

libjpeg-turbo (1:2.0.5-2) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright:
    + Use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Archive, Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Vagrant Cascadian ]
  * debian/patches:
    + Add 1001-use-utc-timestamp.patch. Use UTC timestamp to enable reproducible
      build. (Closes: #968627).

  [ Helmut Grohne ]
  * debian/control:
    + Convert libjpeg-dev to Architecture: any. (Closes: #897646).

  [ Mike Gabriel ]
  * debian/control:
    + Bump Standards-Version: to 4.5.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 01 Jan 2021 21:43:20 +0100
