=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
http://sf.net/libjpeg-turbo/libjpeg-turbo-(.+)\.tar\.gz
